#include <stdio.h>
#include <r_types.h>
#include <r_bin.h>

int main(int argc, char *argv[])
{
	struct r_bin_t bin;
	struct r_bin_section_t *sections;
	int i;
	u64 baddr;

	if (argc != 2) {
		fprintf(stderr, "Usage: %s <bin file>\n", argv[0]);
		return 1;
	}

	/* r_bin initialization */
	r_bin_init(&bin);
	
	/* Open file and autodetect format */
	r_bin_open(&bin, argv[1], 0, NULL);

	/* Get the base address */
	baddr = r_bin_get_baddr(&bin);
	
	/* Get the sections array */
	sections = r_bin_get_sections(&bin);
	
	/* Print */
	for (i = 0; sections && !sections[i].last; i++)
		if (R_BIN_SCN_EXECUTABLE(sections[i].characteristics))
			printf( "0x%08llx - %08lli - %s\n",
					sections[i].offset, sections[i].size, sections[i].name);

	/* r_bin close */
	r_bin_close(&bin);

	return 0;
}
